# Disable strip, it breaks things
%global __os_install_post %{nil}

%define xtool_tuple armv6-rpi-linux-gnueabihf

Name: xtools-%{xtool_tuple}
Version: 1.22.0
Release: 1%{?dist}
Summary: Tool-chain for cross-compilation to Raspberry Pi v1, for Linux distros using hard float and glibc.

Group: Development/Tools
License: GPLv2+
URL: http://crosstool-ng.org
AutoReqProv: no
BuildRequires: crosstool-ng

%description
Tool-chain for cross-compilation to Raspberry Pi v1, for Linux distros using
hard float and glibc (tuple %{xtool_tuple}). Built using crosstool-ng.

Example C compile command:

PATH="/opt/x-tools/%{xtool_tuple}/bin:$PATH" %{xtool_tuple}-gcc --sysroot /opt/x-tools/%{xtool_tuple}/%{xtool_tuple}/sysroot/ foo.c -o foo


%prep
cd %{_builddir}
if [ -e %{name}-%{version} ]
then
    chmod -R +w %{name}-%{version}
    rm -rf %{name}-%{version}
fi
mkdir %{name}-%{version}
cd %{name}-%{version}
# Load stock RPi v1 config, that doesn't quite work...
ct-ng armv6-rpi-linux-gnueabi
# Force hard floating point (through GUI as it changes several things. Using
# nconfig, as menuconfig freezes with fd 2 redirected). Also disable progress
# throbber (doesn't detect non-ttys automatically).
printf '/Pa\n/Prog\n5/Ta\n/Fl\n/ha\n9\n\n' | ct-ng nconfig >/dev/null 2>&1
# Save config, the tuple/name should now be armv6-rpi-linux-gnueabihf
printf '\n\n.\n' | ct-ng saveconfig
# Load the saved config, to normalise and verify tuple is armv6-rpi-linux-gnueabihf
ct-ng %{xtool_tuple}


%build
cd %{_builddir}/%{name}-%{version}
HOME=%{_builddir}/%{name}-%{version} ct-ng build
chmod -R +w %{_builddir}/%{name}-%{version}


%install
cd %{_builddir}/%{name}-%{version}
rm -rf %{buildroot}
install -dm 755 %{buildroot}/opt/x-tools/
cp -ra x-tools/%{xtool_tuple} $RPM_BUILD_ROOT/opt/x-tools/


%files
%defattr(-,root,root,-)
/opt/x-tools/%{xtool_tuple}


%changelog
* Mon Apr 18 2016 Alex Szczuczko <aszczucz@redhat.com> - 1.22.0-1
- Initial package
